

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>SmartRecruiting_BackEnd.data.user_manager &mdash; SmartRecruiting back v2 documentation</title>
  

  
  
  
  

  
  <script type="text/javascript" src="../../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
        <script type="text/javascript" src="../../../_static/jquery.js"></script>
        <script type="text/javascript" src="../../../_static/underscore.js"></script>
        <script type="text/javascript" src="../../../_static/doctools.js"></script>
        <script type="text/javascript" src="../../../_static/language_data.js"></script>
    
    <script type="text/javascript" src="../../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../../index.html" class="icon icon-home"> SmartRecruiting back
          

          
          </a>

          
            
            
              <div class="version">
                v2
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../install.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../contributing.html">Contributing</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../documentation.html">Backend documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">SmartRecruiting back</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../../index.html">Module code</a> &raquo;</li>
        
      <li>SmartRecruiting_BackEnd.data.user_manager</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for SmartRecruiting_BackEnd.data.user_manager</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">SmartRecruiting_BackEnd.data.models</span> <span class="k">import</span> <span class="n">User</span>
<span class="kn">from</span> <span class="nn">SmartRecruiting_BackEnd.data.database</span> <span class="k">import</span> <span class="n">dbSession</span> <span class="k">as</span> <span class="n">dB</span>
<span class="kn">from</span> <span class="nn">SmartRecruiting_BackEnd.data.offer_manager</span> <span class="k">import</span> <span class="n">OfferManager</span>


<div class="viewcode-block" id="UserManager"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.user_manager.UserManager">[docs]</a><span class="k">class</span> <span class="nc">UserManager</span><span class="p">:</span>

<div class="viewcode-block" id="UserManager.get_one_admin"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.user_manager.UserManager.get_one_admin">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">get_one_admin</span><span class="p">():</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        :return: Return the first admin find in the database</span>
<span class="sd">        :rtype: User</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="n">User</span><span class="o">.</span><span class="n">query</span><span class="o">.</span><span class="n">filter_by</span><span class="p">(</span><span class="n">is_admin</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span><span class="o">.</span><span class="n">first</span><span class="p">()</span></div>

<div class="viewcode-block" id="UserManager.get_user_by_id"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.user_manager.UserManager.get_user_by_id">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">get_user_by_id</span><span class="p">(</span><span class="n">id_user</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        :param id_user: id of a user</span>
<span class="sd">        :type id_user: int</span>

<span class="sd">        :return: User obtain with id_user</span>
<span class="sd">        :rtype: dict</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">user</span> <span class="o">=</span> <span class="n">User</span><span class="o">.</span><span class="n">query</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">id_user</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">user</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">return</span> <span class="kc">None</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">user</span><span class="o">.</span><span class="n">serialize</span><span class="p">()</span></div>

<div class="viewcode-block" id="UserManager.get_user_by_email"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.user_manager.UserManager.get_user_by_email">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">get_user_by_email</span><span class="p">(</span><span class="n">email</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        :param email:</span>
<span class="sd">        :type email: str</span>

<span class="sd">        :return: User obtain with email parameter</span>
<span class="sd">        :rtype: User</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">return</span> <span class="n">User</span><span class="o">.</span><span class="n">query</span><span class="o">.</span><span class="n">filter_by</span><span class="p">(</span><span class="n">email</span><span class="o">=</span><span class="n">email</span><span class="p">)</span><span class="o">.</span><span class="n">first</span><span class="p">()</span></div>

<div class="viewcode-block" id="UserManager.add_user"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.user_manager.UserManager.add_user">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">add_user</span><span class="p">(</span><span class="n">name</span><span class="p">,</span> <span class="n">surname</span><span class="p">,</span> <span class="n">role</span><span class="p">,</span> <span class="n">email</span><span class="p">,</span> <span class="n">password</span><span class="p">,</span> <span class="n">is_admin</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Add user in database</span>

<span class="sd">        :param name:</span>
<span class="sd">        :type name: str</span>

<span class="sd">        :param surname:</span>
<span class="sd">        :type surname: str</span>

<span class="sd">        :param role:</span>
<span class="sd">        :type role: str</span>

<span class="sd">        :param email:</span>
<span class="sd">        :type email: str</span>

<span class="sd">        :param password:</span>
<span class="sd">        :type password: str</span>

<span class="sd">        :param is_admin:</span>
<span class="sd">        :type is_admin: bool</span>

<span class="sd">        :return: Boolean if the user was added in database</span>
<span class="sd">        :rtype: bool</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">user</span> <span class="o">=</span> <span class="n">User</span><span class="p">(</span><span class="n">name</span><span class="p">,</span> <span class="n">surname</span><span class="p">,</span> <span class="n">role</span><span class="p">,</span> <span class="n">email</span><span class="p">,</span> <span class="n">password</span><span class="p">,</span> <span class="n">is_admin</span> <span class="o">==</span> <span class="mi">1</span><span class="p">)</span>
        <span class="n">dB</span><span class="o">.</span><span class="n">add</span><span class="p">(</span><span class="n">user</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">dB</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span>
            <span class="k">return</span> <span class="kc">True</span>
        <span class="k">except</span> <span class="ne">Exception</span><span class="p">:</span>
            <span class="n">dB</span><span class="o">.</span><span class="n">rollback</span><span class="p">()</span>
            <span class="k">return</span> <span class="kc">False</span></div>

<div class="viewcode-block" id="UserManager.update_user"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.user_manager.UserManager.update_user">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">update_user</span><span class="p">(</span><span class="n">id_user</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">surname</span><span class="p">,</span> <span class="n">role</span><span class="p">,</span> <span class="n">email</span><span class="p">,</span> <span class="n">password</span><span class="p">,</span> <span class="n">is_admin</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Update user in database</span>

<span class="sd">        :param id_user:</span>
<span class="sd">        :type id_user: int</span>

<span class="sd">        :param name:</span>
<span class="sd">        :type name: str</span>

<span class="sd">        :param surname:</span>
<span class="sd">        :type surname: str</span>

<span class="sd">        :param role:</span>
<span class="sd">        :type role: str</span>

<span class="sd">        :param email:</span>
<span class="sd">        :type email: str</span>

<span class="sd">        :param password:</span>
<span class="sd">        :type password: str</span>

<span class="sd">        :param is_admin:</span>
<span class="sd">        :type is_admin: bool</span>

<span class="sd">        :return: Boolean if the user was updated in database</span>
<span class="sd">        :rtype: bool</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">user</span> <span class="o">=</span> <span class="n">User</span><span class="o">.</span><span class="n">query</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">id_user</span><span class="p">)</span>

        <span class="k">if</span> <span class="n">user</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">return</span> <span class="kc">None</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">name</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">user</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">name</span>
                <span class="k">if</span> <span class="n">surname</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">user</span><span class="o">.</span><span class="n">surname</span> <span class="o">=</span> <span class="n">surname</span>
                <span class="k">if</span> <span class="n">role</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">user</span><span class="o">.</span><span class="n">role</span> <span class="o">=</span> <span class="n">role</span>
                <span class="k">if</span> <span class="n">email</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">user</span><span class="o">.</span><span class="n">email</span> <span class="o">=</span> <span class="n">email</span>
                <span class="k">if</span> <span class="n">password</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">user</span><span class="o">.</span><span class="n">password</span> <span class="o">=</span> <span class="n">password</span>
                <span class="k">if</span> <span class="n">is_admin</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
                    <span class="n">user</span><span class="o">.</span><span class="n">is_admin</span> <span class="o">=</span> <span class="n">is_admin</span> <span class="o">==</span> <span class="mi">1</span>
                <span class="n">dB</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span>
                <span class="k">return</span> <span class="kc">True</span>
            <span class="k">except</span> <span class="ne">Exception</span><span class="p">:</span>
                <span class="n">dB</span><span class="o">.</span><span class="n">rollback</span><span class="p">()</span>
                <span class="k">return</span> <span class="kc">False</span></div>

<div class="viewcode-block" id="UserManager.delete_user"><a class="viewcode-back" href="../../../backend_doc/managers.html#SmartRecruiting_BackEnd.data.user_manager.UserManager.delete_user">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">delete_user</span><span class="p">(</span><span class="n">id_user</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        Delete user in database</span>

<span class="sd">        :param id_user: id of a user</span>
<span class="sd">        :type id_user: int</span>

<span class="sd">        :return: Boolean if the user was deleted in database</span>
<span class="sd">        :rtype: bool</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">user</span> <span class="o">=</span> <span class="n">User</span><span class="o">.</span><span class="n">query</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">id_user</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">user</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">return</span> <span class="kc">None</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="k">for</span> <span class="n">offer</span> <span class="ow">in</span> <span class="n">user</span><span class="o">.</span><span class="n">offers</span><span class="p">:</span>
                    <span class="n">OfferManager</span><span class="o">.</span><span class="n">delete_offer</span><span class="p">(</span><span class="n">offer</span><span class="o">.</span><span class="n">id</span><span class="p">)</span>
                <span class="n">dB</span><span class="o">.</span><span class="n">delete</span><span class="p">(</span><span class="n">user</span><span class="p">)</span>
                <span class="n">dB</span><span class="o">.</span><span class="n">commit</span><span class="p">()</span>
                <span class="k">return</span> <span class="kc">True</span>
            <span class="k">except</span> <span class="ne">Exception</span><span class="p">:</span>
                <span class="n">dB</span><span class="o">.</span><span class="n">rollback</span><span class="p">()</span>
                <span class="k">return</span> <span class="kc">False</span></div></div>
</pre></div>

           </div>
           
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, Projet 21

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>